// ck4dump.c Dan Olson
// Dangerous Dave in the Haunted Mansion sound support by Frenkel Smeijers
#include <stdio.h>
#include <malloc.h>

int main()
{
	unsigned char *sounds;
	FILE *dave, *newfile;

	dave = fopen("dave.exe", "rb");
	if (dave == NULL)
	{
		fprintf (stderr, "Couldn't open DAVE.EXE.\n");
		return -1;
	}

	// Do sounds.dd2
	fseek(dave, 0x259C0, SEEK_SET);
	sounds = (unsigned char *)malloc(0x1868);
	if (sounds == NULL)
	{
		fprintf (stderr, "Couldn't allocate memory\n");
		return -1;
	}
	fread(sounds, sizeof(unsigned char), 0x1868, dave);
	newfile = fopen("sounds.dd2", "wb");
	if (newfile == NULL)
	{
		fprintf(stderr, "Couldn't create SOUNDS.DD2\n");
		return -1;
	}

	fwrite(sounds, sizeof(unsigned char), 0x1868, newfile);
	fclose(newfile);

	free(sounds);
	printf ("SOUNDS.DD2 written...\n");

	fclose(dave);

	printf ("Done.\n");
	return 1;
}
